From 2fd4879ca6267044053846a89d4d07c13b29e3ea Mon Sep 17 00:00:00 2001
From: Zhao Zhili <wantlamy@gmail.com>
Date: Tue, 18 Jul 2017 14:41:08 +0800
Subject: [PATCH 1/2] demux: adaptive: fix out of range exception

---
 modules/demux/adaptive/http/HTTPConnection.cpp | 14 ++++++++++----
 1 file changed, 10 insertions(+), 4 deletions(-)

diff --git a/modules/demux/adaptive/http/HTTPConnection.cpp b/modules/demux/adaptive/http/HTTPConnection.cpp
index 03156c6..0ebbd18 100644
--- a/modules/demux/adaptive/http/HTTPConnection.cpp
+++ b/modules/demux/adaptive/http/HTTPConnection.cpp
@@ -241,12 +241,18 @@ int HTTPConnection::parseReply()
     while(!line.empty() && line.compare("\r\n"))
     {
         size_t split = line.find_first_of(':');
-        size_t value = split + 1;
+        if(split != std::string::npos)
+        {
+            size_t value = split + 1;
+
+            while(value < line.size() && line[value] == ' ')
+                value++;
 
-        while(line.at(value) == ' ')
-            value++;
+            if(value > line.size())
+                value = line.size();
+            onHeader(line.substr(0, split), line.substr(value));
+        }
 
-        onHeader(line.substr(0, split), line.substr(value));
         line = readLine();
     }
 
-- 
2.7.4

